﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ServiceModel;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.Routing;

namespace CSharp_Silverlight_HowDoISamples
{
    [ServiceContract]
    public interface IGeoDataGetting
    {
        [OperationContract]
        string GetPointShapeById(string featureId);

        [OperationContract]
        string GetRoute(string startFeatureId, string endFeatureId, string algorithm);

        [OperationContract]
        Dictionary<string, Collection<string>> GetRouteResult(string startFeatureId, string endFeatureId, string algorithm);

        [OperationContract]
        string GetFastestRoute(string startFeatureId, string endFeatureId);

        [OperationContract]
        string GetRouteByCoordinate(string startPoint, string endPoint);

        [OperationContract]
        Dictionary<string, string> GetRouteSegmentByFeatureId(string featureId);

        [OperationContract]
        string GetFeatureById(string id);

        [OperationContract]
        Collection<string> GetFeaturesByIds(IEnumerable<string> ids);

        [OperationContract]
        string GetServiceArea(string centerPoint, TimeSpan drivingTime, float speed, string speedUnit);

        [OperationContract]
        string GetOneWayRoute(string startFeatureId, string endFeatureId);

        [OperationContract]
        string GetCenterPointOnLine(string pointShape);

        [OperationContract]
        string GetRouteViaStops(string startPoint, Collection<string> stopPoints, int iterations);
    }
}
